




















































































































 


































































































































































 































































































































































































 



















































 










 








































































































































































































































 










                                
                                

                                
                                

                                
                                

                                

























































subroutine TmunuBase_SetStressEnergyState (cctk_dim,cctk_gsh,cctk_lsh,cctk_lbnd,cctk_ubnd,cctk_tile_min,cctk_tile_max,cctk_ash,cctk&
  &_alignment,cctk_alignment_offset,cctk_from,cctk_to,cctk_bbox,cctk_delta_time,cctk_time,cctk_delta_space,cctk_origin_space,cctk_l&
  &evfac,cctk_levoff,cctk_levoffdenom,cctk_timefac,cctk_convlevel,cctk_convfac,cctk_nghostzones,cctk_iteration,cctkGH,cctk_ash1,cct&
  &k_ash2,cctk_ash3, alp,alp_p,alp_p_p,betax,betax_p,betax_p_p,betay,betay_p,betay_p_p,betaz,betaz_p,betaz_p_p,coarse_dx,coarse_dy,&
  &coarse_dz,conformal_state,dtalp,dtalp_p,dtalp_p_p,dtbetax,dtbetax_p,dtbetax_p_p,dtbetay,dtbetay_p,dtbetay_p_p,dtbetaz,dtbetaz_p,&
  &dtbetaz_p_p,dtlapse_state,dtshift_state,eTtt,eTtt_p,eTtt_p_p,eTtx,eTtx_p,eTtx_p_p,eTty,eTty_p,eTty_p_p,eTtz,eTtz_p,eTtz_p_p,eTxx&
  &,eTxx_p,eTxx_p_p,eTxy,eTxy_p,eTxy_p_p,eTxz,eTxz_p,eTxz_p_p,eTyy,eTyy_p,eTyy_p_p,eTyz,eTyz_p,eTyz_p_p,eTzz,eTzz_p,eTzz_p_p,gxx,gx&
  &x_p,gxx_p_p,gxy,gxy_p,gxy_p_p,gxz,gxz_p,gxz_p_p,gyy,gyy_p,gyy_p_p,gyz,gyz_p,gyz_p_p,gzz,gzz_p,gzz_p_p,kxx,kxx_p,kxx_p_p,kxy,kxy_&
  &p,kxy_p_p,kxz,kxz_p,kxz_p_p,kyy,kyy_p,kyy_p_p,kyz,kyz_p,kyz_p_p,kzz,kzz_p,kzz_p_p,psi,psix,psixx,psixy,psixz,psiy,psiyy,psiyz,ps&
  &iz,psizz,r,shift_state,stress_energy_state,x,y,z)
  implicit none

  INTEGER cctk_dim
  integer, parameter :: cctki_use_cctk_dim = kind(cctk_dim)
  INTEGER cctk_gsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_gsh = kind(cctk_gsh)
  INTEGER cctk_lsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_lsh = kind(cctk_lsh)
  INTEGER cctk_lbnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_lbnd = kind(cctk_lbnd)
  INTEGER cctk_ubnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_ubnd = kind(cctk_ubnd)
  INTEGER cctk_tile_min (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_min = kind(cctk_tile_min)
  INTEGER cctk_tile_max (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_max = kind(cctk_tile_max)
  INTEGER cctk_ash (cctk_dim)
  integer, parameter :: cctki_use_cctk_ash = kind(cctk_ash)
  INTEGER cctk_alignment
  integer, parameter :: cctki_use_cctk_alignment = kind(cctk_alignment)
  INTEGER cctk_alignment_offset
  integer, parameter :: cctki_use_cctk_alignment_offset = kind(cctk_alignment_offset)
  INTEGER cctk_from (cctk_dim)
  integer, parameter :: cctki_use_cctk_from = kind(cctk_from)
  INTEGER cctk_to (cctk_dim)
  integer, parameter :: cctki_use_cctk_to = kind(cctk_to)
  INTEGER cctk_bbox (2*cctk_dim)
  integer, parameter :: cctki_use_cctk_bbox = kind(cctk_bbox)
  REAL*8 cctk_delta_time
  integer, parameter :: cctki_use_cctk_delta_time = kind(cctk_delta_time)
  REAL*8 cctk_time
  integer, parameter :: cctki_use_cctk_time = kind(cctk_time)
  REAL*8 cctk_delta_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_delta_space = kind(cctk_delta_space)
  REAL*8 cctk_origin_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_origin_space = kind(cctk_origin_space)
  INTEGER cctk_levfac (cctk_dim)
  integer, parameter :: cctki_use_cctk_levfac = kind(cctk_levfac)
  INTEGER cctk_levoff (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoff = kind(cctk_levoff)
  INTEGER cctk_levoffdenom (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoffdenom = kind(cctk_levoffdenom)
  INTEGER cctk_timefac
  integer, parameter :: cctki_use_cctk_timefac = kind(cctk_timefac)
  INTEGER cctk_convlevel
  integer, parameter :: cctki_use_cctk_convlevel = kind(cctk_convlevel)
  INTEGER cctk_convfac
  integer, parameter :: cctki_use_cctk_convfac = kind(cctk_convfac)
  INTEGER cctk_nghostzones (cctk_dim)
  integer, parameter :: cctki_use_cctk_nghostzones = kind(cctk_nghostzones)
  INTEGER cctk_iteration
  integer, parameter :: cctki_use_cctk_iteration = kind(cctk_iteration)
  integer*8 cctkGH
  integer, parameter :: cctki_use_cctkGH = kind(cctkGH)
  INTEGER cctk_ash1
  integer, parameter :: cctki_use_cctk_ash1 = kind(cctk_ash1)
  INTEGER cctk_ash2
  integer, parameter :: cctki_use_cctk_ash2 = kind(cctk_ash2)
  INTEGER cctk_ash3
  integer, parameter :: cctki_use_cctk_ash3 = kind(cctk_ash3)
  INTEGER*4 :: stress_energy_state
  integer, parameter :: cctki_use_stress_energy_state = kind(stress_energy_state)
  characTer*8, intent(IN) :: alp
  integer, parameter :: cctki_use_alp = kind(alp)
  characTer*8, intent(IN) :: alp_p
  integer, parameter :: cctki_use_alp_p = kind(alp_p)
  characTer*8, intent(IN) :: alp_p_p
  integer, parameter :: cctki_use_alp_p_p = kind(alp_p_p)
  characTer*8, intent(IN) :: betax
  integer, parameter :: cctki_use_betax = kind(betax)
  characTer*8, intent(IN) :: betax_p
  integer, parameter :: cctki_use_betax_p = kind(betax_p)
  characTer*8, intent(IN) :: betax_p_p
  integer, parameter :: cctki_use_betax_p_p = kind(betax_p_p)
  characTer*8, intent(IN) :: betay
  integer, parameter :: cctki_use_betay = kind(betay)
  characTer*8, intent(IN) :: betay_p
  integer, parameter :: cctki_use_betay_p = kind(betay_p)
  characTer*8, intent(IN) :: betay_p_p
  integer, parameter :: cctki_use_betay_p_p = kind(betay_p_p)
  characTer*8, intent(IN) :: betaz
  integer, parameter :: cctki_use_betaz = kind(betaz)
  characTer*8, intent(IN) :: betaz_p
  integer, parameter :: cctki_use_betaz_p = kind(betaz_p)
  characTer*8, intent(IN) :: betaz_p_p
  integer, parameter :: cctki_use_betaz_p_p = kind(betaz_p_p)
  characTer*8, intent(IN) :: coarse_dx
  integer, parameter :: cctki_use_coarse_dx = kind(coarse_dx)
  characTer*8, intent(IN) :: coarse_dy
  integer, parameter :: cctki_use_coarse_dy = kind(coarse_dy)
  characTer*8, intent(IN) :: coarse_dz
  integer, parameter :: cctki_use_coarse_dz = kind(coarse_dz)
  characTer*8, intent(IN) :: conformal_state
  integer, parameter :: cctki_use_conformal_state = kind(conformal_state)
  characTer*8, intent(IN) :: dtalp
  integer, parameter :: cctki_use_dtalp = kind(dtalp)
  characTer*8, intent(IN) :: dtalp_p
  integer, parameter :: cctki_use_dtalp_p = kind(dtalp_p)
  characTer*8, intent(IN) :: dtalp_p_p
  integer, parameter :: cctki_use_dtalp_p_p = kind(dtalp_p_p)
  characTer*8, intent(IN) :: dtbetax
  integer, parameter :: cctki_use_dtbetax = kind(dtbetax)
  characTer*8, intent(IN) :: dtbetax_p
  integer, parameter :: cctki_use_dtbetax_p = kind(dtbetax_p)
  characTer*8, intent(IN) :: dtbetax_p_p
  integer, parameter :: cctki_use_dtbetax_p_p = kind(dtbetax_p_p)
  characTer*8, intent(IN) :: dtbetay
  integer, parameter :: cctki_use_dtbetay = kind(dtbetay)
  characTer*8, intent(IN) :: dtbetay_p
  integer, parameter :: cctki_use_dtbetay_p = kind(dtbetay_p)
  characTer*8, intent(IN) :: dtbetay_p_p
  integer, parameter :: cctki_use_dtbetay_p_p = kind(dtbetay_p_p)
  characTer*8, intent(IN) :: dtbetaz
  integer, parameter :: cctki_use_dtbetaz = kind(dtbetaz)
  characTer*8, intent(IN) :: dtbetaz_p
  integer, parameter :: cctki_use_dtbetaz_p = kind(dtbetaz_p)
  characTer*8, intent(IN) :: dtbetaz_p_p
  integer, parameter :: cctki_use_dtbetaz_p_p = kind(dtbetaz_p_p)
  characTer*8, intent(IN) :: dtlapse_state
  integer, parameter :: cctki_use_dtlapse_state = kind(dtlapse_state)
  characTer*8, intent(IN) :: dtshift_state
  integer, parameter :: cctki_use_dtshift_state = kind(dtshift_state)
  characTer*8, intent(IN) :: ettt
  integer, parameter :: cctki_use_ettt = kind(ettt)
  characTer*8, intent(IN) :: ettt_p
  integer, parameter :: cctki_use_ettt_p = kind(ettt_p)
  characTer*8, intent(IN) :: ettt_p_p
  integer, parameter :: cctki_use_ettt_p_p = kind(ettt_p_p)
  characTer*8, intent(IN) :: ettx
  integer, parameter :: cctki_use_ettx = kind(ettx)
  characTer*8, intent(IN) :: ettx_p
  integer, parameter :: cctki_use_ettx_p = kind(ettx_p)
  characTer*8, intent(IN) :: ettx_p_p
  integer, parameter :: cctki_use_ettx_p_p = kind(ettx_p_p)
  characTer*8, intent(IN) :: etty
  integer, parameter :: cctki_use_etty = kind(etty)
  characTer*8, intent(IN) :: etty_p
  integer, parameter :: cctki_use_etty_p = kind(etty_p)
  characTer*8, intent(IN) :: etty_p_p
  integer, parameter :: cctki_use_etty_p_p = kind(etty_p_p)
  characTer*8, intent(IN) :: ettz
  integer, parameter :: cctki_use_ettz = kind(ettz)
  characTer*8, intent(IN) :: ettz_p
  integer, parameter :: cctki_use_ettz_p = kind(ettz_p)
  characTer*8, intent(IN) :: ettz_p_p
  integer, parameter :: cctki_use_ettz_p_p = kind(ettz_p_p)
  characTer*8, intent(IN) :: etxx
  integer, parameter :: cctki_use_etxx = kind(etxx)
  characTer*8, intent(IN) :: etxx_p
  integer, parameter :: cctki_use_etxx_p = kind(etxx_p)
  characTer*8, intent(IN) :: etxx_p_p
  integer, parameter :: cctki_use_etxx_p_p = kind(etxx_p_p)
  characTer*8, intent(IN) :: etxy
  integer, parameter :: cctki_use_etxy = kind(etxy)
  characTer*8, intent(IN) :: etxy_p
  integer, parameter :: cctki_use_etxy_p = kind(etxy_p)
  characTer*8, intent(IN) :: etxy_p_p
  integer, parameter :: cctki_use_etxy_p_p = kind(etxy_p_p)
  characTer*8, intent(IN) :: etxz
  integer, parameter :: cctki_use_etxz = kind(etxz)
  characTer*8, intent(IN) :: etxz_p
  integer, parameter :: cctki_use_etxz_p = kind(etxz_p)
  characTer*8, intent(IN) :: etxz_p_p
  integer, parameter :: cctki_use_etxz_p_p = kind(etxz_p_p)
  characTer*8, intent(IN) :: etyy
  integer, parameter :: cctki_use_etyy = kind(etyy)
  characTer*8, intent(IN) :: etyy_p
  integer, parameter :: cctki_use_etyy_p = kind(etyy_p)
  characTer*8, intent(IN) :: etyy_p_p
  integer, parameter :: cctki_use_etyy_p_p = kind(etyy_p_p)
  characTer*8, intent(IN) :: etyz
  integer, parameter :: cctki_use_etyz = kind(etyz)
  characTer*8, intent(IN) :: etyz_p
  integer, parameter :: cctki_use_etyz_p = kind(etyz_p)
  characTer*8, intent(IN) :: etyz_p_p
  integer, parameter :: cctki_use_etyz_p_p = kind(etyz_p_p)
  characTer*8, intent(IN) :: etzz
  integer, parameter :: cctki_use_etzz = kind(etzz)
  characTer*8, intent(IN) :: etzz_p
  integer, parameter :: cctki_use_etzz_p = kind(etzz_p)
  characTer*8, intent(IN) :: etzz_p_p
  integer, parameter :: cctki_use_etzz_p_p = kind(etzz_p_p)
  characTer*8, intent(IN) :: gxx
  integer, parameter :: cctki_use_gxx = kind(gxx)
  characTer*8, intent(IN) :: gxx_p
  integer, parameter :: cctki_use_gxx_p = kind(gxx_p)
  characTer*8, intent(IN) :: gxx_p_p
  integer, parameter :: cctki_use_gxx_p_p = kind(gxx_p_p)
  characTer*8, intent(IN) :: gxy
  integer, parameter :: cctki_use_gxy = kind(gxy)
  characTer*8, intent(IN) :: gxy_p
  integer, parameter :: cctki_use_gxy_p = kind(gxy_p)
  characTer*8, intent(IN) :: gxy_p_p
  integer, parameter :: cctki_use_gxy_p_p = kind(gxy_p_p)
  characTer*8, intent(IN) :: gxz
  integer, parameter :: cctki_use_gxz = kind(gxz)
  characTer*8, intent(IN) :: gxz_p
  integer, parameter :: cctki_use_gxz_p = kind(gxz_p)
  characTer*8, intent(IN) :: gxz_p_p
  integer, parameter :: cctki_use_gxz_p_p = kind(gxz_p_p)
  characTer*8, intent(IN) :: gyy
  integer, parameter :: cctki_use_gyy = kind(gyy)
  characTer*8, intent(IN) :: gyy_p
  integer, parameter :: cctki_use_gyy_p = kind(gyy_p)
  characTer*8, intent(IN) :: gyy_p_p
  integer, parameter :: cctki_use_gyy_p_p = kind(gyy_p_p)
  characTer*8, intent(IN) :: gyz
  integer, parameter :: cctki_use_gyz = kind(gyz)
  characTer*8, intent(IN) :: gyz_p
  integer, parameter :: cctki_use_gyz_p = kind(gyz_p)
  characTer*8, intent(IN) :: gyz_p_p
  integer, parameter :: cctki_use_gyz_p_p = kind(gyz_p_p)
  characTer*8, intent(IN) :: gzz
  integer, parameter :: cctki_use_gzz = kind(gzz)
  characTer*8, intent(IN) :: gzz_p
  integer, parameter :: cctki_use_gzz_p = kind(gzz_p)
  characTer*8, intent(IN) :: gzz_p_p
  integer, parameter :: cctki_use_gzz_p_p = kind(gzz_p_p)
  characTer*8, intent(IN) :: kxx
  integer, parameter :: cctki_use_kxx = kind(kxx)
  characTer*8, intent(IN) :: kxx_p
  integer, parameter :: cctki_use_kxx_p = kind(kxx_p)
  characTer*8, intent(IN) :: kxx_p_p
  integer, parameter :: cctki_use_kxx_p_p = kind(kxx_p_p)
  characTer*8, intent(IN) :: kxy
  integer, parameter :: cctki_use_kxy = kind(kxy)
  characTer*8, intent(IN) :: kxy_p
  integer, parameter :: cctki_use_kxy_p = kind(kxy_p)
  characTer*8, intent(IN) :: kxy_p_p
  integer, parameter :: cctki_use_kxy_p_p = kind(kxy_p_p)
  characTer*8, intent(IN) :: kxz
  integer, parameter :: cctki_use_kxz = kind(kxz)
  characTer*8, intent(IN) :: kxz_p
  integer, parameter :: cctki_use_kxz_p = kind(kxz_p)
  characTer*8, intent(IN) :: kxz_p_p
  integer, parameter :: cctki_use_kxz_p_p = kind(kxz_p_p)
  characTer*8, intent(IN) :: kyy
  integer, parameter :: cctki_use_kyy = kind(kyy)
  characTer*8, intent(IN) :: kyy_p
  integer, parameter :: cctki_use_kyy_p = kind(kyy_p)
  characTer*8, intent(IN) :: kyy_p_p
  integer, parameter :: cctki_use_kyy_p_p = kind(kyy_p_p)
  characTer*8, intent(IN) :: kyz
  integer, parameter :: cctki_use_kyz = kind(kyz)
  characTer*8, intent(IN) :: kyz_p
  integer, parameter :: cctki_use_kyz_p = kind(kyz_p)
  characTer*8, intent(IN) :: kyz_p_p
  integer, parameter :: cctki_use_kyz_p_p = kind(kyz_p_p)
  characTer*8, intent(IN) :: kzz
  integer, parameter :: cctki_use_kzz = kind(kzz)
  characTer*8, intent(IN) :: kzz_p
  integer, parameter :: cctki_use_kzz_p = kind(kzz_p)
  characTer*8, intent(IN) :: kzz_p_p
  integer, parameter :: cctki_use_kzz_p_p = kind(kzz_p_p)
  characTer*8, intent(IN) :: psi
  integer, parameter :: cctki_use_psi = kind(psi)
  characTer*8, intent(IN) :: psix
  integer, parameter :: cctki_use_psix = kind(psix)
  characTer*8, intent(IN) :: psixx
  integer, parameter :: cctki_use_psixx = kind(psixx)
  characTer*8, intent(IN) :: psixy
  integer, parameter :: cctki_use_psixy = kind(psixy)
  characTer*8, intent(IN) :: psixz
  integer, parameter :: cctki_use_psixz = kind(psixz)
  characTer*8, intent(IN) :: psiy
  integer, parameter :: cctki_use_psiy = kind(psiy)
  characTer*8, intent(IN) :: psiyy
  integer, parameter :: cctki_use_psiyy = kind(psiyy)
  characTer*8, intent(IN) :: psiyz
  integer, parameter :: cctki_use_psiyz = kind(psiyz)
  characTer*8, intent(IN) :: psiz
  integer, parameter :: cctki_use_psiz = kind(psiz)
  characTer*8, intent(IN) :: psizz
  integer, parameter :: cctki_use_psizz = kind(psizz)
  characTer*8, intent(IN) :: r
  integer, parameter :: cctki_use_r = kind(r)
  characTer*8, intent(IN) :: shift_state
  integer, parameter :: cctki_use_shift_state = kind(shift_state)
  characTer*8, intent(IN) :: x
  integer, parameter :: cctki_use_x = kind(x)
  characTer*8, intent(IN) :: y
  integer, parameter :: cctki_use_y = kind(y)
  characTer*8, intent(IN) :: z
  integer, parameter :: cctki_use_z = kind(z)
  INTEGER*4 stress_energy_at_RHS
  integer, parameter :: cctki_use_stress_energy_at_RHS = kind(stress_energy_at_RHS)
  INTEGER*4 support_old_CalcTmunu_mechanism
  integer, parameter :: cctki_use_support_old_CalcTmunu_mechanism = kind(support_old_CalcTmunu_mechanism)
  COMMON /TmunuBaserest/stress_energy_at_RHS, support_old_CalcTmunu_mechanism
  integer*8 prolongation_type
  integer, parameter :: cctki_use_prolongation_type = kind(prolongation_type)
  INTEGER*4 stress_energy_storage
  integer, parameter :: cctki_use_stress_energy_storage = kind(stress_energy_storage)
  INTEGER*4 timelevels
  integer, parameter :: cctki_use_timelevels = kind(timelevels)
  COMMON /TmunuBasepriv/prolongation_type, stress_energy_storage, timelevels
  
  stress_energy_state = stress_energy_storage
end subroutine TmunuBase_SetStressEnergyState
